#ifndef H_STRINGLIB

#define H_STRINGLIB

#define MIN_STRING_CAPACITY 64

typedef struct string string_t;

string_t* string_new();

string_t* string_from_chars(const char* str);

char* string_cpy_to_chars(const string_t* str);

string_t* string_copy(const string_t* str);

const char* string_cstr(string_t* str);

unsigned long long string_get_size(const string_t* str);

unsigned long long string_get_capacity(const string_t* str);

void string_set_min_capacity(string_t* str, const unsigned long long size);

void string_append(string_t* dest, const string_t* source);

void string_append_char(string_t* dest, const char c);

void string_append_chars(string_t* dest, const char* source);

void string_print(const string_t* str);

string_t* string_substr(const string_t* str, const unsigned long long position, const unsigned long long length);

void string_clear(string_t* str);

void string_erase(string_t* str, const unsigned long long position, const unsigned long long length);

void string_free(string_t* str);

#endif