#include <stdlib.h>
#include <stdio.h>
#include "token.h"

token_t* token_new_int(int32_t value){
    token_t* new_token = malloc(sizeof(token_t));
    new_token->type = INTEGER;
    new_token->value_i = value;
    return new_token;
}

token_t* token_new_quote(string_t* value){
    token_t* new_token = malloc(sizeof(token_t));
    new_token->type = QUOTE;
    new_token->value_q = value;
    return new_token;
}

token_t* token_new_reference(char value){
    token_t* new_token = malloc(sizeof(token_t));
    new_token->type = REFERENCE;
    new_token->value_r = value;
    return new_token;
}

token_t* token_copy(token_t* tok){
    token_t* new_token = malloc(sizeof(token_t));
    int type = tok->type;
    new_token->type = type;
    switch(type){
        case INTEGER:
            new_token->value_i = tok->value_i;
            break;
        case REFERENCE:
            new_token->value_r = tok->value_r;
            break;
        case QUOTE:
            new_token->value_q = string_copy(tok->value_q);
            break;
        default:
            exit(3);
    }
    return new_token;
}

void token_print(const token_t* tok){
    switch(tok->type){
        case INTEGER:
            printf("INTEGER[%d]", tok->value_i);
            break;
        case QUOTE:
            printf("QUOTE[\"%s\"]", string_cstr(tok->value_q));
            break;
        case REFERENCE:
            printf("REFERENCE['%c']", tok->value_r);
            break;
        default:
            (void)0;
    }
    return;
}

void token_full_free(token_t* tok){
    if(tok->type == QUOTE){
        string_free(tok->value_q);
    }
    free(tok);
}

void token_free(token_t* tok){
    free(tok);
}