#ifndef H_TOKEN

#define H_TOKEN
#include <stdint.h>
#include "stringlib.h"


#define INTEGER 0
#define QUOTE 1
#define REFERENCE 2

typedef struct token
{
    int type;
    union{
        int32_t value_i;
        string_t* value_q;
        char value_r;
    };
} token_t;

token_t* token_new_int(int32_t value);

token_t* token_new_quote(string_t* value);

token_t* token_new_reference(char value);

token_t* token_copy(token_t* tok);

void token_print(const token_t* tok);

void token_full_free(token_t* tok);

void token_free(token_t* tok);

#endif